package hexedit.gui;

import javax.swing.text.*;

import org.gjt.sp.jedit.*;

/**
 * Enforces correct length and prevents tab and newline characters.
 *
 * @author     mace
 * @created    June 13, 2003
 * @modified   $Date: 2003/06/23 07:00:41 $ by $Author: bemace $
 * @version    $Revision: 1.1 $
 * @see        hexedit.gui.OverwriteDocument
 */

public class AsciiDocument extends OverwriteDocument {
	public AsciiDocument() { }

	public void insertString(int offset, String s, AttributeSet attributeSet) throws BadLocationException {
		if (s.indexOf("\t") >= 0 || s.indexOf("\r") >= 0 || s.indexOf("\n") >= 0) {
			return;
		}
		
		if (offset < 16) {
			super.insertString(offset, s, attributeSet);
		}
	}
}

