package hexedit.gui;

import java.awt.*;
import javax.swing.*;

import org.gjt.sp.jedit.*;
import org.gjt.sp.jedit.textarea.*;

/**
 * Description of the Class
 *
 * @author     mace
 * @created    June 11, 2003
 * @modified   $Date: 2003/06/23 07:00:41 $ by $Author: bemace $
 * @version    $Revision: 1.4 $
 */
public class AsciiEditor extends AbstractTableCellEditor {
	private AsciiRenderer _field = new AsciiRenderer();

	public AsciiEditor() {
		_field.setBorder(null);
		_field.setEditable(true);
		_field.setDocument(new AsciiDocument());
	}

	public Component getTableCellEditorComponent(JTable table,
			Object value,
			boolean isSelected,
			int row, int column) {
		_field.reconfigureFor(table, value, row, column);

		if (table.getSelectedRow() == row) {
			_field.setSelectionStart(table.getSelectedColumn() - 1);
			_field.setSelectionEnd(table.getSelectedColumn());
		} else {
			_field.setSelectionStart(0);
			_field.setSelectionEnd(0);
		}

		return _field;
	}

	public Object getCellEditorValue() {
		return _field.getText();
	}
}

