package hexedit.gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.basic.*;
import javax.swing.table.TableCellRenderer;
import javax.swing.text.*;

import org.gjt.sp.jedit.*;
import org.gjt.sp.jedit.textarea.*;

/**
 * Description of the Class
 *
 * @author     mace
 * @created    June 11, 2003
 * @modified   $Date: 2003/06/13 06:38:12 $ by $Author: bemace $
 * @version    $Revision: 1.2 $
 */
public class AsciiRenderer extends JTextField implements TableCellRenderer {
	public AsciiRenderer() {
		setBorder(null);
		setEditable(true);
	}
	
	public Component getTableCellRendererComponent(JTable table,
			Object value,
			boolean isSelected,
			boolean hasFocus,
			int row,
			int column) {
				reconfigureFor(table,value,row,column);
		return this;
	}
	
	protected void reconfigureFor(JTable table, Object value, int row, int col) {
		setFont(table.getFont());
		JEditTextArea textArea = jEdit.getActiveView().getTextArea();
		setCaretColor(textArea.getPainter().getCaretColor());
		setSelectionColor(textArea.getPainter().getSelectionColor());		setForeground(table.getForeground());
		setBackground(table.getBackground());
		if (value != null) {
			setText(value+"");
		}
		if (table.getSelectedRow() == row) {
			setSelectionStart(table.getSelectedColumn()-1);
			setSelectionEnd(table.getSelectedColumn());
		} else {
			setSelectionStart(0);
			setSelectionEnd(0);
		}
	}
	
	public Insets getInsets() {
		return new Insets(0,10,0,0);	
	}
}

