package hexedit.gui;

import java.awt.*;
import javax.swing.*;
import java.io.*;

import org.gjt.sp.jedit.*;
import org.gjt.sp.jedit.msg.*;

import hexedit.*;
import hexedit.io.*;

/**
 * Description of the Class
 *
 * @author     mace
 * @created    June 11, 2003
 * @modified   $Date: 2003/06/13 06:38:12 $ by $Author: bemace $
 * @version    $Revision: 1.4 $
 */
public class EditPanel extends JPanel {
	private BufferedHexFile _file;
	protected HexTable _table;

	public EditPanel() {
		setLayout(new BorderLayout());
		_table = new HexTable(buildModel());
		add(new HexEditToolBar(this), BorderLayout.NORTH);
		add(new JScrollPane(_table), BorderLayout.CENTER);
	}

	protected HexTableModel buildModel() {
		return new HexTableModel(new EmptyData());
	}

	public void removeNotify() {
		super.removeNotify();
		closeHexData();
	}

	public void openHexData(BufferedHexFile file) {
		_file = file;
		try {
			_file.load();
			_table.setModel(new HexTableModel(file));
			_table.repaint();
		} catch (IOException e) {
			JOptionPane.showMessageDialog(jEdit.getActiveView(), e, "Can't open file", JOptionPane.ERROR_MESSAGE);
		}
	}

	public void save() {
		try {
			_file.save();
		} catch (IOException e) {
			JOptionPane.showMessageDialog(jEdit.getActiveView(), e, "Can't save file", JOptionPane.ERROR_MESSAGE);
		}
	}

	public void closeHexData() {
		if (_file.getStatus() == _file.FILE_CHANGED || _file.getStatus() == _file.FILE_DELETED) {
			int r = JOptionPane.showConfirmDialog(jEdit.getActiveView(), "Save file before closing?", "File changed", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
			if (r == JOptionPane.CANCEL_OPTION) {
				return;
			} else if (r == JOptionPane.YES_OPTION) {
				try {
					_file.save();
				} catch (IOException e) {
					JOptionPane.showMessageDialog(jEdit.getActiveView(), e, "Can't save file", JOptionPane.ERROR_MESSAGE);
					return;
				}
			}
		}
		_table.setModel(new HexTableModel(new EmptyData()));
	}
}

