package hexedit.gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.tree.*;
import java.awt.event.MouseEvent;
import java.util.EventObject;

import hexedit.*;

/**
 * Description of the Class
 *
 * @author     mace
 * @created    May 22, 2003
 * @modified   $Date: 2003/06/13 06:38:12 $ by $Author: bemace $
 * @version    $Revision: 1.2 $
 */
public class HexCellEditor extends AbstractTableCellEditor {

	private HexRenderer renderer = new HexRenderer();
	private JTextField _field = new JTextField(2);

	public HexCellEditor() {
		_field.setBorder(null);
		_field.setHorizontalAlignment(_field.CENTER);
		_field.setDocument(new HexDocument());
		//_field.setCaret(new BlockCaret());
	}

	public Component getTableCellEditorComponent(JTable table,
			Object value,
			boolean isSelected,
			int row, int col) {
		_field.setFont(table.getFont());
		Byte b = (Byte) value;
		int i = NumberUtilities.byteToInt(b.byteValue());
		String hex = Integer.toHexString(i).toUpperCase();
		if (hex.length() == 1) {
			_field.setText("0" + hex);
		} else {
			_field.setText(hex);
		}
		_field.selectAll();
		_field.setMargin(new Insets(0, 2, 0, 0));
		return _field;
	}

	public void setEditorValue(Object value) {
		this.value = value;
	}

	public Object getCellEditorValue() {
		return _field.getText();
	}

	public boolean shouldSelectCell() {
		return false;
	}
	
}

