package hexedit.gui;

import javax.swing.text.*;

import org.gjt.sp.jedit.*;

/**
 * Allows only valid hex values to be entered. Enforces 2-digit length.
 *
 * @author     mace
 * @created    June 13, 2003
 * @modified   $Date: 2003/06/13 07:21:48 $ by $Author: bemace $
 * @version    $Revision: 1.3 $
 * @see        hexedit.gui.OverwriteDocument
 */

public class HexDocument extends OverwriteDocument {
	public HexDocument() { }

	public void insertString(int offset, String s, AttributeSet attributeSet) throws BadLocationException {
		try {
			Integer.valueOf(s, 16);
			if (offset < 2) {
				super.insertString(offset, s, attributeSet);
			}
		} catch (NumberFormatException e) {
			Object[] args = {s};
			GUIUtilities.error(jEdit.getActiveView(), "hexedit.error.bad-number", args);
		}
	}
}

