package hexedit.gui;

import javax.swing.text.*;

/**
 * This document causes all inserts to overwrite existing text, 
 * and does not allow the removal of text.
 */
public class OverwriteDocument extends PlainDocument {
	/**
	 * Over-ridden to call replace() 
	 */
	public void insertString(int offset, String s, AttributeSet attributeSet) throws BadLocationException {
		try {
			super.remove(offset,s.length());
		} catch (BadLocationException e) {}
		super.insertString(offset,s,attributeSet);
	}

	/**
	 * Over-ridden to prevent the removal of text
	 */
	public void remove(int offset, int length) {}
	
}
