package hexedit.io;

import hexedit.*;

/**
 * Provides some fake hex data for testing purposes.
 *
 * @author     mace
 * @created    June 10, 2003
 * @modified   $Date: 2003/06/12 06:47:38 $ by $Author: bemace $
 * @version    $Revision: 1.3 $
 */
public class DummyData extends AbstractHexData {
	private int[][] intData = {
		{10,20,30,40,50,60,70,80,90,100,110,120,130,140,150, 160},
		{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16},
		{2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32},
		{254,253,252,251,250,249,248,247,246,245,244,243,242,241,240,239}
	};
	private byte[][] data;

	public DummyData() {
		data = new byte[intData.length][intData[0].length];
		for (int i = 0; i < intData.length; i++) {
			for (int j = 0; j < intData[0].length; j++) {
				data[i][j] = (byte) intData[i][j];	
			}
		}
	}
	
	public int getRowCount() { 
		return data.length;
	}

	public int getColumnCount() { 
		return data[0].length;
	}

	public int getLastRowSize() { 
		return 13;
	}

	public byte getByte(int row, int col) { 
		return data[row][col];
	}

	public void setByte(int row, int col, byte value) { 
		data[row][col] = value;
		System.out.println("DummyData: set row "+row+", col "+col+" to "+value);
	}

	public byte[] getRow(int row) { 
		return data[row];
	}

	public long length() {
		return intData.length * intData[0].length;	
	}
}

