package hexedit.util;

import java.util.*;

public class ByteBuffer {
	private ArrayList _buffer = new ArrayList();
	
	public void setByte(int offset, byte b) {
		_buffer.set(offset,new Byte(b));
	}
	
	public byte getByte(int offset) {
		return ((Byte) _buffer.get(offset)).byteValue();
	}
	
	/**
	 * Fills the provided byte array with bytes, starting from the given offset
	 */
	public void readBytes(int offset, byte[] bytes) {
		for (int i = 0; i < bytes.length; i++) {
			bytes[i] = getByte(i+offset);	
		}
	}
	
	/**
	 * Loads the given byte array into the buffer, removing any existing bytes.
	 */
	public void load(byte[] bytes) {
		_buffer = new ArrayList();
		for (int i = 0; i < bytes.length; i++) {
			_buffer.add(i,new Byte(bytes[i]));	
		}
	}
	
	public byte[] getBytes() {
		byte[] bytes = new byte[size()];
		for (int i = 0; i < size(); i++) {
			bytes[i] = getByte(i);
		}
		return bytes;
	}

	public int size() {
		return _buffer.size();	
	}
}
