package hexedit.util;

import junit.framework.*;

public class ByteBufferTest extends TestCase {
	private byte[] test = {
		(byte) 1, (byte) 10, (byte) 75, (byte) 150, (byte) 254, (byte) 255
	};
	
	public ByteBufferTest(String name) {
		super(name);
	}
	
	public void testLoad() {
		ByteBuffer b = new ByteBuffer();
		b.load(test);
		for (int i = 0; i < test.length; i++) {
			assertEquals(test[i], b.getByte(i));
		}
	}
	
	public void testRead() {
		ByteBuffer b = new ByteBuffer();
		b.load(test);
		byte[] read = new byte[test.length];
		b.readBytes(0,read);
		
		for (int i = 0; i < test.length; i++) {
			assertEquals(test[i],read[i]);
		}
		
		byte[] shortRead = new byte[3];
		b.readBytes(1,shortRead);
		
		for (int i = 0; i < shortRead.length; i++) {
			assertEquals(test[i+1], shortRead[i]);
		}
	}
}
